﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace VisualStateManager
{
    public class Condition : ICondition
    {
        // Private fields ----------------------------------------------------

        private bool value;

        // Protected methods -------------------------------------------------

        protected void OnValueChanged(bool newValue)
        {
            if (ValueChanged != null)
                ValueChanged(this, new ValueChangedEventArgs(newValue));
        }

        // Public methods ----------------------------------------------------

        public Condition(bool newValue = false)
        {
            value = newValue;
        }

        // Public properties -------------------------------------------------

        public bool Value
        {
            get
            {
                return value;
            }
            set
            {
                if (value != this.value)
                {
                    this.value = value;
                    OnValueChanged(this.value);
                }
            }
        }

        public event ValueChangedHandler ValueChanged;
    }
}
