﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace VisualStateManager
{
    public class NegateCondition : ICondition
    {
        // Private fields ----------------------------------------------------

        private ICondition condition;

        // Private methods ---------------------------------------------------

        private void HandleInnerConditionValueChanged(object sender, ValueChangedEventArgs e)
        {
            OnValueChanged(!(e.Value));
        }

        // Protected methods -------------------------------------------------

        protected void OnValueChanged(bool newValue)
        {
            if (ValueChanged != null)
                ValueChanged(this, new ValueChangedEventArgs(newValue));
        }

        // Public methods ----------------------------------------------------

        public NegateCondition(ICondition newCondition)
        {
            if (newCondition == null)
                throw new ArgumentNullException("newCondition");

            condition = newCondition;
            condition.ValueChanged += HandleInnerConditionValueChanged;
        }

        // Public properties -------------------------------------------------

        public bool Value
        {
            get
            {
                return !condition.Value;
            }
        }

        public event ValueChangedHandler ValueChanged;
    }
}
